Subject: Re: bug#31325: 27.0.50; PROPOSAL: introduce a new function to recenter without redisplaying the frame

From: John Shahid <[email-masked]>
Date: Sun, 01 Jul 2018 18:58:09 +0000

Eli Zaretskii <[email-masked]> writes:

>> From: John Shahid <[email-masked]>
>> Cc: [email-masked], [email-masked], [email-masked]
>> Date: Sun, 01 Jul 2018 17:18:08 +0000
>>
>> >> It just occurred to me that this change will break backward
>> >> comparability for those who bind some key to the `recenter' command,
>> >> since now the second argument will always be nil and thus won't
>> >> redisplay.  Should we also change the interactive form of recenter to
>> >> use "p" for the second argument?  That way the second arg is never nil
>> >> when used interactively.
>> >
>> > I think you are right.
>> >
>> > Alternatively, we could simply make 'recenter' behave specially in
>> > interactive invocations.  But in any case, incompatible changes in
>> > behavior are bad, and should be avoided.
>>
>> I am happy to make the change. Should we just revert this patch and
>> instead of adding a new argument change the behavior of`recenter' to
>> redraw if called interactively ?
>>
>> How can we determine from C whether the function is called interactively
>> ? Is it ok to use `called-interactively-p' ?
>
> That'd be gross, I think.  Going through the interactive spec, as you
> suggested originally, should be much simpler.

Updated the interactive spec in the attached patch and made the
necessary changes to the manual and documentation.  I also missed a
place where `recenter-top-bottom' was calling `recenter' without passing
a non-nil value for REDISPLAY that I also fixed in the attached patch.

Let me know what you think.

Thanks,

>From 3ac3d2d5f60593776563e27d4b406b2776de9b96 Mon Sep 17 00:00:00 2001
From: John Shahid <[email-masked]>
Date: Sun, 1 Jul 2018 14:48:24 -0400
Subject: [PATCH] Keep `recenter' behavior backward compatible when called
 interactively

* window.c (recenter): Change the interactive spec to always pass a
  non-nil value to the REDISPLAY argument when called interactively.
* window.el (recenter-top-bottom): Make sure recenter's second
  argument is non-nil everywhere.
* windows.texi (Textual Scrolling): Edit documentation of `recenter'.
---
 doc/lispref/windows.texi | 3 ++-
 lisp/window.el           | 2 +-
 src/window.c             | 4 ++--
 3 files changed, 5 insertions(+), 4 deletions(-)

diff --git a/doc/lispref/windows.texi b/doc/lispref/windows.texi
index 9740bbebf2..8903922da5 100644
--- a/doc/lispref/windows.texi
+++ b/doc/lispref/windows.texi
@@ -4154,7 +4154,8 @@ Textual Scrolling
 @code{recenter} puts the line containing point in the middle of the
 window.  If @var{count} is @code{nil} and @var{redisplay} is
 non-@code{nil}, this function may redraw the frame, according to the
-value of @code{recenter-redisplay}.
+value of @code{recenter-redisplay}. Interactive calls pass non-‘nil’
+for @var{redisplay}.
 
 When @code{recenter} is called interactively, @var{count} is the raw
 prefix argument.  Thus, typing @kbd{C-u} as the prefix sets the
diff --git a/lisp/window.el b/lisp/window.el
index 6d9d8bdcd2..d56bed63da 100644
--- a/lisp/window.el
+++ b/lisp/window.el
@@ -8767,7 +8767,7 @@ recenter-top-bottom
  With plain `C-u', move current line to window center."
   (interactive "P")
   (cond
-   (arg (recenter arg))			; Always respect ARG.
+   (arg (recenter arg t))                 ; Always respect ARG.
    (t
     (setq recenter-last-op
 	  (if (eq this-command last-command)
diff --git a/src/window.c b/src/window.c
index a966e99ca8..ffa2236cf8 100644
--- a/src/window.c
+++ b/src/window.c
@@ -5898,7 +5898,7 @@ displayed_window_lines (struct window *w)
 }

-DEFUN ("recenter", Frecenter, Srecenter, 0, 2, "P",
+DEFUN ("recenter", Frecenter, Srecenter, 0, 2, "P\np",
        doc: /* Center point in selected window and maybe redisplay frame.
 With a numeric prefix argument ARG, recenter putting point on screen line ARG
 relative to the selected window.  If ARG is negative, it counts up from the
@@ -5910,7 +5910,7 @@ non-nil, also erase the entire frame and redraw it (when
 `auto-resize-tool-bars' is set to `grow-only', this resets the
 tool-bar's height to the minimum height needed); if
 `recenter-redisplay' has the special value `tty', then only tty frames
-are redrawn.
+are redrawn.  Interactive calls pass non-nil for REDISPLAY.
 
 Just C-u as prefix means put point in the center of the window
 and redisplay normally--don't erase and redraw the frame.  */)
-- 
2.18.0